trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
# for calling outside of FAI, first
-# source /a/bin/fai-wrapper
-# then to set classes with: fai-setclass OPT1...
-# which sets CLASS_OPT1=true...
+# - source /a/bin/fai-wrapper
+# - set any appropriate classes with: fai-setclass OPT1... which sets CLASS_OPT1=true...
+# or run eval-fai-classfile FILE
#
# OPTIONS:
#
# raid10.
if [[ $SPECIAL_DISK ]]; then
- export CLASS_REPARTITION=true
+ export CLASS_REPARTITION=true
fi
# # fai's setup-storage won't do btrfs on luks,
# if we are not running in fai, skiptask won't be defined, so carry on.
skiptask partition || ! type skiptask
+if ! type -p devbyid; then
+ for d in $FAI/distro-install-common \
+ /a/bin/fai/fai/config/distro-install-common $FAI $PWD; do
+ [[ -d $d ]] || continue
+ if [[ -e $d/devbyid ]]; then
+ devbyid=$d/devbyid
+ devbyid() { $devbyid "$@"; }
+ break
+ fi
+ done
+ if [[ ! $devbyid ]]; then
+ echo "$0: error: failed to find devbyid script" >&2
+ exit 1
+ fi
+fi
+
#### begin configuration
add-part() { # add partition suffix to $dev
- local d ret
- if [[ $# == 1 ]]; then
- d=$dev
- part=$1
- else
- d=$1
- part=$2
- fi
- if [[ $d == /dev/disk/by-id/* ]]; then
- ret=$d-part$part
- else
- ret=$d$part
- fi
- echo $ret
+ local d ret
+ if [[ $# == 1 ]]; then
+ d=$dev
+ part=$1
+ else
+ d=$1
+ part=$2
+ fi
+ if [[ $d == /dev/disk/by-id/* ]]; then
+ ret=$d-part$part
+ else
+ ret=$d$part
+ fi
+ echo $ret
}
bootdev() { add-part $@ $bootn; }
swap-cryptdev() { crypt-dev $(swapdev $@); }
root-cryptname() { crypt-name $(rootdev $@); }
swap-cryptname() { crypt-name $(swapdev $@); }
-devbyid() {
- local f
- for f in $FAI/distro-install-common/devbyid \
- /a/bin/fai/fai/config/distro-install-common/devbyid; do
- if [[ -e $f ]]; then $f "$@"; break; fi
- done
-
-}
##### end function defs
if ifclass REPARTITION;then
- partition=true # force a full wipe
+ partition=true # force a full wipe
else
- partition=false # change to true to force a full wipe
+ partition=false # change to true to force a full wipe
fi
ssds=()
cd /sys/block
for disk in [sv]d[a-z]; do
- case $(cat $disk/queue/rotational) in
- 0) ssds+=(/dev/$disk) ;;
- 1) hdds+=(/dev/$disk) ;;
- *) echo "$0: error: unknown /sys/block/$disk/queue/rotational: \
+ case $(cat $disk/queue/rotational) in
+ 0) ssds+=(/dev/$disk) ;;
+ 1) hdds+=(/dev/$disk) ;;
+ *) echo "$0: error: unknown /sys/block/$disk/queue/rotational: \
$(cat $disk/queue/rotational)"; exit 1 ;;
- esac
+ esac
done
# install all ssds, or if there are none, all hdds.
# very odd, but convenient for ignoring them here.
# TODO: find a reliable way to ignore them.
if ! ifclass ROTATIONAL && (( ${#ssds[@]} > 0 )); then
- short_devs=( ${ssds[@]} )
+ short_devs=( ${ssds[@]} )
else
- short_devs=( ${hdds[@]} )
+ short_devs=( ${hdds[@]} )
fi
# check if the partitions exist have the right filesystems
#blkid="$(blkid -s TYPE)"
for dev in ${short_devs[@]}; do
- if $partition; then break; fi
- y=$(readlink -f $dev)
- arr=($y[0-9])
- [[ ${#arr[@]} == "${lastn}" ]] || partition=true
- for (( i=1; i <= lastn; i++ )); do
- [[ -e ${dev}$i ]] || partition=true
- done
- # On one system, blkid is missing some partitions.
- # maybe we need a flag, like FUZZY_BLKID or something, so we
- # can check that at least some exist.
- # for x in "`rootdev`: TYPE=\"crypto_LUKS\"" "`bootdev`: TYPE=\"btrfs\""; do
- # echo "$blkid" | grep -Fx "$x" &>/dev/null || partition=true
- # done
+ if $partition; then break; fi
+ y=$(readlink -f $dev)
+ arr=($y[0-9])
+ [[ ${#arr[@]} == "${lastn}" ]] || partition=true
+ for (( i=1; i <= lastn; i++ )); do
+ [[ -e ${dev}$i ]] || partition=true
+ done
+ # On one system, blkid is missing some partitions.
+ # maybe we need a flag, like FUZZY_BLKID or something, so we
+ # can check that at least some exist.
+ # for x in "`rootdev`: TYPE=\"crypto_LUKS\"" "`bootdev`: TYPE=\"btrfs\""; do
+ # echo "$blkid" | grep -Fx "$x" &>/dev/null || partition=true
+ # done
done
if $partition && ifclass PARTITION_PROMPT; then
- echo "Press any key except ctrl-c to continue and partition these drives:"
- echo " ${short_devs[*]}"
- read -r
+ echo "Press any key except ctrl-c to continue and partition these drives:"
+ echo " ${short_devs[*]}"
+ read -r
fi
devs=()
shopt -s extglob
for short_dev in ${short_devs[@]}; do
- devs+=($(devbyid $short_dev))
+ devs+=($(devbyid $short_dev))
done
+if [[ ! ${devs[@]} ]]; then
+ echo "$0: error: failed to detect devs" >&2
+ exit 1
+fi
first=false
boot_devs=()
for dev in ${devs[@]}; do
- if ifclass frodo; then
- # I ran into a machine where the bios doesn't know about some disks,
- # so 1st stage of grub also doesn't know about them.
- # Also, grub does not support mounting degraded btrfs as far as
- # I can tell with some googling.
- # From within an arch install env, I could detect them by noting
- # their partitions were mixed with the next disk in /dev/disk/by-path,
- # and I have mixed model disks, and I could see the 8 models which showed
- # up in the bios, and thus see which 2 models were missing.
- # hdparm -I /dev/sdh will give model info in linux.
- # However, in fai on jessie, /dev/disk/by-path dir doesn't exist,
- # and I don't see another way, so I'm hardcoding them.
- # We still put grub on them and partition them the same, for uniformity
- # and in case they get moved to a system that can recognize them,
- # we just exclude them from the boot filesystem.
- cd /dev/disk/by-id/
- bad_disk=false
- for id in ata-TOSHIBA_MD04ACA500_8539K4TQFS9A \
- ata-TOSHIBA_MD04ACA500_Y5IFK6IJFS9A; do
- if [[ $(readlink -f $id) == "$(readlink -f $dev)" ]]; then
- bad_disk=true
- break
- fi
- done
- $bad_disk || boot_devs+=(`bootdev`)
- else
- boot_devs+=(`bootdev`)
- fi
- if [[ $boot_devs && $first ]]; then
- first_grub_extdev=`grub_extdev`
- first=false
- fi
+ if ifclass frodo; then
+ # I ran into a machine where the bios doesn't know about some disks,
+ # so 1st stage of grub also doesn't know about them.
+ # Also, grub does not support mounting degraded btrfs as far as
+ # I can tell with some googling.
+ # From within an arch install env, I could detect them by noting
+ # their partitions were mixed with the next disk in /dev/disk/by-path,
+ # and I have mixed model disks, and I could see the 8 models which showed
+ # up in the bios, and thus see which 2 models were missing.
+ # hdparm -I /dev/sdh will give model info in linux.
+ # However, in fai on jessie, /dev/disk/by-path dir doesn't exist,
+ # and I don't see another way, so I'm hardcoding them.
+ # We still put grub on them and partition them the same, for uniformity
+ # and in case they get moved to a system that can recognize them,
+ # we just exclude them from the boot filesystem.
+ cd /dev/disk/by-id/
+ bad_disk=false
+ for id in ata-TOSHIBA_MD04ACA500_8539K4TQFS9A \
+ ata-TOSHIBA_MD04ACA500_Y5IFK6IJFS9A; do
+ if [[ $(readlink -f $id) == "$(readlink -f $dev)" ]]; then
+ bad_disk=true
+ break
+ fi
+ done
+ $bad_disk || boot_devs+=(`bootdev`)
+ else
+ boot_devs+=(`bootdev`)
+ fi
+ if [[ $boot_devs && $first ]]; then
+ first_grub_extdev=`grub_extdev`
+ first=false
+ fi
done
if ifclass RAID0 || (( ${#boot_devs[@]} < 4 )); then
- raid_level=0
+ raid_level=0
else
- raid_level=10
- # need double the space if we are raid 10, and then
- # might as well give some extra.
- boot_mib=$((boot_mib * 3))
+ raid_level=10
+ # need double the space if we are raid 10, and then
+ # might as well give some extra.
+ boot_mib=$((boot_mib * 3))
fi
if [[ ! $DISTRO ]]; then
- if ifclass VOL_STRETCH_BOOTSTRAP; then
- DISTRO=debianstretch_bootstrap
- elif ifclass VOL_STRETCH; then
- DISTRO=debianstretch
- elif ifclass VOL_TESTING; then
- DISTRO=debiantesting
- elif ifclass VOL_XENIAL; then
- DISTRO=ubuntuxenial
- elif ifclass VOL_BELENOS; then
- DISTRO=trisquelbelenos
- elif ifclass VOL_FLIDAS; then
- DISTRO=trisquelflidas
- else
- echo "PARTITIONER ERROR: no distro class/var set" >&2
- exit 1
- fi
+ if ifclass VOL_STRETCH_BOOTSTRAP; then
+ DISTRO=debianstretch_bootstrap
+ elif ifclass VOL_STRETCH; then
+ DISTRO=debianstretch
+ elif ifclass VOL_TESTING; then
+ DISTRO=debiantesting
+ elif ifclass VOL_XENIAL; then
+ DISTRO=ubuntuxenial
+ elif ifclass VOL_BELENOS; then
+ DISTRO=trisquelbelenos
+ elif ifclass VOL_FLIDAS; then
+ DISTRO=trisquelflidas
+ else
+ echo "PARTITIONER ERROR: no distro class/var set" >&2
+ exit 1
+ fi
fi
first_boot_dev=${boot_devs[0]}
bpart() { # btrfs a partition
- case $raid_level in
- 0) mkfs.btrfs -f $@ ;;
- 10) mkfs.btrfs -f -m raid10 -d raid10 $@ ;;
- esac
+ case $raid_level in
+ 0) mkfs.btrfs -f $@ ;;
+ 10) mkfs.btrfs -f -m raid10 -d raid10 $@ ;;
+ esac
}
luks_dir=${LUKS_DIR:-/var/lib/fai/config/distro-install-common/luks}
if [[ ! -e $luks_dir/host-$HOSTNAME ]]; then
- echo "$0: error: no key for hostname at $luks_dir/host-$HOSTNAME" >&2
- exit 1
+ echo "$0: error: no key for hostname at $luks_dir/host-$HOSTNAME" >&2
+ exit 1
fi
lukspw=$(cat $luks_dir/iank)
# # ian: disabled by chaning to tpnew while I use the tp host.
# # note, corresponding changes in /b/ds/keyscript-{on,off}
if ifclass tpnew; then
- lukspw=$(cat $luks_dir/traci)
+ lukspw=$(cat $luks_dir/traci)
fi
if ifclass demohost; then
- lukspw=x
+ lukspw=x
fi
# 1.5 x based on https://access.redhat.com/documentation/en-US/Red_Hat_Enterprise_Linux/7/html/Installation_Guide/sect-disk-partitioning-setup-x86.html#sect-custom-partitioning-x86
swap_mib=$(( $(grep ^MemTotal: /proc/meminfo | \
- awk '{print $2}') * 3/(${#devs[@]} * 2 ) / 1024 ))
+ awk '{print $2}') * 3/(${#devs[@]} * 2 ) / 1024 ))
mkdir -p /tmp/fai
root_devs=()
for dev in ${devs[@]}; do
- root_devs+=(`rootdev`)
+ root_devs+=(`rootdev`)
done
shopt -s nullglob
if $partition; then
- ### begin wipefs
- if [[ ! $SPECIAL_DISK ]]; then
- for dev in ${devs[@]}; do
- # if we repartition to the same as an old partition,
- # we don't want any old fses hanging around.
- for (( i=1; i <= lastn; i++ )); do
- x=$(add-part $dev $i)
- [[ -e $x ]] || continue
- count_down=10
- # wipefs has failed, manual run works, google suggests timing issue
- while ! wipefs -a $x; do
- sleep 2
- count_down=$((count_down - 1))
- (( count_down > 0 )) || exit 1
- done
- done
+ ### begin wipefs
+ if [[ ! $SPECIAL_DISK ]]; then
+ for dev in ${devs[@]}; do
+ # if we repartition to the same as an old partition,
+ # we don't want any old fses hanging around.
+ for (( i=1; i <= lastn; i++ )); do
+ x=$(add-part $dev $i)
+ [[ -e $x ]] || continue
+ count_down=10
+ # wipefs has failed, manual run works, google suggests timing issue
+ while ! wipefs -a $x; do
+ sleep 2
+ count_down=$((count_down - 1))
+ (( count_down > 0 )) || exit 1
done
+ done
+ done
+ fi
+ ### end wipefs
+
+ for dev in ${devs[@]}; do
+ if [[ $SPECIAL_DISK ]]; then
+ dev=$(devbyid $SPECIAL_DISK)
fi
- ### end wipefs
- for dev in ${devs[@]}; do
- if [[ $SPECIAL_DISK ]]; then
- dev=$(devbyid $SPECIAL_DISK)
- fi
-
- # parted will round up the disk size. Do -1 so we can have
- # fully 1MiB unit partitions for easy resizing of the last partition.
- # Otherwise we would pass in -0 for the end argument for the last partition.
- #
- # Note: parted print error output is expected. example:
- # Error: /dev/vda: unrecognised disk label
- disk_mib=$(( $(parted -m $dev unit MiB print | \
- sed -nr "s#^/dev/[^:]+:([0-9]+).*#\1#p") - 1))
- root_end=$(( disk_mib - swap_mib - boot_mib / ${#boot_devs[@]} ))
- swap_end=$(( root_end + swap_mib))
-
- parted -s $dev mklabel gpt
- # MiB because parted complains about alignment otherwise.
- pcmd="parted -a optimal -s -- $dev"
- $pcmd mkpart primary ext3 12MiB ${root_end}MiB
- # without naming, systemd gives us misc errors like:
- # dev-disk-by\x2dpartlabel-primary.device: Dev dev-disk-by\x2dpartlabel-primary.device appeared twice
- $pcmd name $rootn root
- # normally a swap is type "linux-swap", but this is encrypted swap. using that
- # label will confuse systemd.
- $pcmd mkpart primary "" ${root_end}MiB ${swap_end}MiB
- $pcmd name $swapn swap
- $pcmd mkpart primary "" ${swap_end}MiB ${disk_mib}MiB
- $pcmd name $bootn boot
- # i only need a few k, but googling min size,
- # I found someone saying that gparted required
- # required at least 8 because of their hard drive cylinder size.
- # And 8 is still very tiny.
- $pcmd mkpart primary "ext2" 4MiB 12MiB
- $pcmd name $grub_extn grubext
- # gpt ubuntu cloud image uses ~4 mb for this partition. fai uses 1 MiB.
- # so, I use 3, whatever.
- # note: parted manual saying cheap flash media
- # should to start at 4.
- $pcmd mkpart primary "" 1MiB 4MiB
- $pcmd name $bios_grubn biosgrub
- $pcmd set $bios_grubn bios_grub on
- $pcmd set $bootn boot on # generally not needed on modern systems
- # the mkfs failed before on a vm, which prompted me to add
- # sleep .1
- # then it failed again on a physical machine
- # with:
- # Device /dev/disk/by-id/foo doesn't exist or access denied,
- # so I added a wait until it existed.
- # Then I added the mkfs.ext2, which claimed to succeed,
- # but then couldn't be found upon reboot. In that case we didn't
- # wait at all. So I've added a 3 second minimum wait.
- sleep 3
- secs=0
- while [[ ! -e `rootdev` ]] && (( secs < 10 )); do
- sleep 1
- secs=$((secs +1))
- done
- # Holds just a single file, rarely written, so
- # use ext2, like was often used for the /boot partition.
- # This exists because grub can only persist data to a non-cow fs.
- # And we use persisting a var in grub to do a one time boot.
- # We could pass the data on the kernel command line and persist it
- # to grubenv after booting, but that relies on the boot always succeeding.
- # This is just a bit more robust, and it could work for booting
- # into ipxe which can't persist data, if we ever got that working.
- mkfs.ext2 `grub_extdev`
- yes YES | cryptsetup luksFormat `rootdev` $luks_dir/host-$HOSTNAME \
- -c aes-cbc-essiv:sha256 -s 256 || [[ $? == 141 ]]
- yes "$lukspw" | \
- cryptsetup luksAddKey --key-file $luks_dir/host-$HOSTNAME \
- `rootdev` || [[ $? == 141 ]]
- # background: Keyfile and password are treated just
- # like 2 ways to input a passphrase, so we don't actually need to have
- # different contents of keyfile and passphrase, but it makes some
- # security sense to a really big randomly generated passphrase
- # as much as possible, so we have both.
- #
- # This would remove the keyfile.
- # yes 'test' | cryptsetup luksRemoveKey /dev/... \
- # /key/file || [[ $? == 141 ]]
-
- cryptsetup luksOpen `rootdev` `root-cryptname` \
- --key-file $luks_dir/host-$HOSTNAME
-
- if [[ $SPECIAL_DISK ]]; then
- exit 0
- fi
+ # parted will round up the disk size. Do -1 so we can have
+ # fully 1MiB unit partitions for easy resizing of the last partition.
+ # Otherwise we would pass in -0 for the end argument for the last partition.
+ #
+ # Note: parted print error output is expected. example:
+ # Error: /dev/vda: unrecognised disk label
+ disk_mib=$(( $(parted -m $dev unit MiB print | \
+ sed -nr "s#^/dev/[^:]+:([0-9]+).*#\1#p") - 1))
+ root_end=$(( disk_mib - swap_mib - boot_mib / ${#boot_devs[@]} ))
+ swap_end=$(( root_end + swap_mib))
+
+ parted -s $dev mklabel gpt
+ # MiB because parted complains about alignment otherwise.
+ pcmd="parted -a optimal -s -- $dev"
+ $pcmd mkpart primary ext3 12MiB ${root_end}MiB
+ # without naming, systemd gives us misc errors like:
+ # dev-disk-by\x2dpartlabel-primary.device: Dev dev-disk-by\x2dpartlabel-primary.device appeared twice
+ $pcmd name $rootn root
+ # normally a swap is type "linux-swap", but this is encrypted swap. using that
+ # label will confuse systemd.
+ $pcmd mkpart primary "" ${root_end}MiB ${swap_end}MiB
+ $pcmd name $swapn swap
+ $pcmd mkpart primary "" ${swap_end}MiB ${disk_mib}MiB
+ $pcmd name $bootn boot
+ # i only need a few k, but googling min size,
+ # I found someone saying that gparted required
+ # required at least 8 because of their hard drive cylinder size.
+ # And 8 is still very tiny.
+ $pcmd mkpart primary "ext2" 4MiB 12MiB
+ $pcmd name $grub_extn grubext
+ # gpt ubuntu cloud image uses ~4 mb for this partition. fai uses 1 MiB.
+ # so, I use 3, whatever.
+ # note: parted manual saying cheap flash media
+ # should to start at 4.
+ $pcmd mkpart primary "" 1MiB 4MiB
+ $pcmd name $bios_grubn biosgrub
+ $pcmd set $bios_grubn bios_grub on
+ $pcmd set $bootn boot on # generally not needed on modern systems
+ # the mkfs failed before on a vm, which prompted me to add
+ # sleep .1
+ # then it failed again on a physical machine
+ # with:
+ # Device /dev/disk/by-id/foo doesn't exist or access denied,
+ # so I added a wait until it existed.
+ # Then I added the mkfs.ext2, which claimed to succeed,
+ # but then couldn't be found upon reboot. In that case we didn't
+ # wait at all. So I've added a 3 second minimum wait.
+ sleep 3
+ secs=0
+ while [[ ! -e `rootdev` ]] && (( secs < 10 )); do
+ sleep 1
+ secs=$((secs +1))
done
- ls -la /dev/btrfs-control # this was probably for debugging...
- sleep 1
- bpart $(for dev in ${devs[@]}; do root-cryptdev; done)
- bpart ${boot_devs[@]}
+ # Holds just a single file, rarely written, so
+ # use ext2, like was often used for the /boot partition.
+ # This exists because grub can only persist data to a non-cow fs.
+ # And we use persisting a var in grub to do a one time boot.
+ # We could pass the data on the kernel command line and persist it
+ # to grubenv after booting, but that relies on the boot always succeeding.
+ # This is just a bit more robust, and it could work for booting
+ # into ipxe which can't persist data, if we ever got that working.
+ mkfs.ext2 `grub_extdev`
+ yes YES | cryptsetup luksFormat `rootdev` $luks_dir/host-$HOSTNAME \
+ -c aes-cbc-essiv:sha256 -s 256 || [[ $? == 141 ]]
+ yes "$lukspw" | \
+ cryptsetup luksAddKey --key-file $luks_dir/host-$HOSTNAME \
+ `rootdev` || [[ $? == 141 ]]
+ # background: Keyfile and password are treated just
+ # like 2 ways to input a passphrase, so we don't actually need to have
+ # different contents of keyfile and passphrase, but it makes some
+ # security sense to a really big randomly generated passphrase
+ # as much as possible, so we have both.
+ #
+ # This would remove the keyfile.
+ # yes 'test' | cryptsetup luksRemoveKey /dev/... \
+ # /key/file || [[ $? == 141 ]]
+
+ cryptsetup luksOpen `rootdev` `root-cryptname` \
+ --key-file $luks_dir/host-$HOSTNAME
+
+ if [[ $SPECIAL_DISK ]]; then
+ exit 0
+ fi
+ done
+ ls -la /dev/btrfs-control # this was probably for debugging...
+ sleep 1
+ bpart $(for dev in ${devs[@]}; do root-cryptdev; done)
+ bpart ${boot_devs[@]}
else
- for dev in ${devs[@]}; do
- mkfs.ext2 `grub_extdev`
- cryptsetup luksOpen `rootdev` `root-cryptname` \
- --key-file $luks_dir/host-$HOSTNAME
- done
- sleep 1
+ for dev in ${devs[@]}; do
+ mkfs.ext2 `grub_extdev`
+ cryptsetup luksOpen `rootdev` `root-cryptname` \
+ --key-file $luks_dir/host-$HOSTNAME
+ done
+ sleep 1
fi
if [[ $DISTRO != debianstretch_bootstrap ]]; then
- # bootstrap distro doesn't use separate encrypted root.
- mount -o subvolid=0 $first_root_crypt /mnt
- # systemd creates subvolumes we want to delete.
- s=($(btrfs subvolume list --sort=-path /mnt |
- sed -rn "s#^.*path\s*(root_$DISTRO/\S+)\s*\$#\1#p"))
- for subvol in ${s[@]}; do btrfs subvolume delete /mnt/$subvol; done
- btrfs subvolume set-default 0 /mnt
- [[ ! -e /mnt/root_$DISTRO ]] || btrfs subvolume delete /mnt/root_$DISTRO
-
- ## create subvols ##
- cd /mnt
-
- btrfs subvolume create root_$DISTRO
-
- mkdir -p /mnt/root_$DISTRO/boot
- # could set default subvol like this, but no reason to.
- # btrfs subvolume set-default \
- # $(btrfs subvolume list . | grep "root_$DISTRO$" | awk '{print $2}') .
-
- # no cow on the root filesystem. it's setup is fully scripted,
- # if it's messed up, we will just recreated it,
- # and we can get better perf with this.
- # I can't remember exactly why, but this is preferable to mounting with
- # -o nodatacow, I think because subvolumes inherit that.
- chattr -Rf +C root_$DISTRO
- cd /
- umount /mnt
+ # bootstrap distro doesn't use separate encrypted root.
+ mount -o subvolid=0 $first_root_crypt /mnt
+ # systemd creates subvolumes we want to delete.
+ s=($(btrfs subvolume list --sort=-path /mnt |
+ sed -rn "s#^.*path\s*(root_$DISTRO/\S+)\s*\$#\1#p"))
+ for subvol in ${s[@]}; do btrfs subvolume delete /mnt/$subvol; done
+ btrfs subvolume set-default 0 /mnt
+ [[ ! -e /mnt/root_$DISTRO ]] || btrfs subvolume delete /mnt/root_$DISTRO
+
+ ## create subvols ##
+ cd /mnt
+
+ btrfs subvolume create root_$DISTRO
+
+ mkdir -p /mnt/root_$DISTRO/boot
+ # could set default subvol like this, but no reason to.
+ # btrfs subvolume set-default \
+ # $(btrfs subvolume list . | grep "root_$DISTRO$" | awk '{print $2}') .
+
+ # no cow on the root filesystem. it's setup is fully scripted,
+ # if it's messed up, we will just recreated it,
+ # and we can get better perf with this.
+ # I can't remember exactly why, but this is preferable to mounting with
+ # -o nodatacow, I think because subvolumes inherit that.
+ chattr -Rf +C root_$DISTRO
+ cd /
+ umount /mnt
fi
mount -o subvolid=0 $first_boot_dev /mnt
cp $FAI/distro-install-common/libreboot_grub.cfg /mnt/grub2
if [[ $DISTRO == debianstretch_bootstrap ]]; then
- # this is just convenience for the libreboot_grub config
- # so we can glob the other ones easier.
- boot_vol=$DISTRO
+ # this is just convenience for the libreboot_grub config
+ # so we can glob the other ones easier.
+ boot_vol=$DISTRO
else
- boot_vol=boot_$DISTRO
+ boot_vol=boot_$DISTRO
fi
[[ ! -e /mnt/$boot_vol ]] || btrfs subvolume delete /mnt/$boot_vol
btrfs subvolume create $boot_vol
umount /mnt
if [[ $DISTRO == debianstretch_bootstrap ]]; then
- cat > /tmp/fai/fstab <<EOF
+ cat > /tmp/fai/fstab <<EOF
$first_boot_dev / btrfs noatime,subvol=$boot_vol 0 0
EOF
- cat >/tmp/fai/disk_var.sh <<EOF
+ cat >/tmp/fai/disk_var.sh <<EOF
BOOT_DEVICE="${short_devs[@]}"
ROOT_PARTITION=$first_boot_dev
EOF
else
- # note, fai creates the mountpoints listed here
- cat > /tmp/fai/fstab <<EOF
+ # note, fai creates the mountpoints listed here
+ cat > /tmp/fai/fstab <<EOF
$first_root_crypt / btrfs noatime,subvol=root_$DISTRO 0 0
$first_root_crypt /mnt/root btrfs noatime,subvolid=0 0 0
$first_boot_dev /boot btrfs noatime,subvol=$boot_vol 0 0
EOF
- swaps=()
- for dev in ${devs[@]}; do
- swaps+=(`swap-cryptname`)
- cat >>/tmp/fai/crypttab <<EOF
+ swaps=()
+ for dev in ${devs[@]}; do
+ swaps+=(`swap-cryptname`)
+ cat >>/tmp/fai/crypttab <<EOF
`root-cryptname` `rootdev` none keyscript=/root/keyscript,discard,luks
`swap-cryptname` `swapdev` /dev/urandom swap,cipher=aes-xts-plain64,size=256,hash=ripemd160
EOF
- cat >> /tmp/fai/fstab <<EOF
+ cat >> /tmp/fai/fstab <<EOF
`swap-cryptdev` none swap sw 0 0
EOF
- done
+ done
- # fai would do this:
- #BOOT_DEVICE=\${BOOT_DEVICE:-"${devs[0]}"}
+ # fai would do this:
+ #BOOT_DEVICE=\${BOOT_DEVICE:-"${devs[0]}"}
- # note: swaplist seems to do nothing.
- cat >/tmp/fai/disk_var.sh <<EOF
+ # note: swaplist seems to do nothing.
+ cat >/tmp/fai/disk_var.sh <<EOF
BOOT_DEVICE="${short_devs[@]}"
BOOT_PARTITION=\${BOOT_PARTITION:-$first_boot_dev}
# ROOT_PARTITIONS is added by me, used in arch setup.